Attribute VB_Name = "mdMMRegistry"
'
' Copyright (C) 2003-2006 Funambol
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdMMRegistry.bas                                     *
'****************************************************************

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long


Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubkey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long


Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal _
hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType _
As Long, lpData As Long, ByVal cbData As Long) As Long


Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const REG_BINARY = 3
Public Const REG_CREATED_NEW_KEY = &H1
Public Const REG_DWORD = 4
Public Const REG_DWORD_BIG_ENDIAN = 5
Public Const REG_DWORD_LITTLE_ENDIAN = 4
Public Const REG_EXPAND_SZ = 2
Public Const REG_FULL_RESOURCE_DESCRIPTOR = 9
Public Const REG_LINK = 6
Public Const REG_MULTI_SZ = 7
Public Const REG_NONE = 0
Public Const REG_NOTIFY_CHANGE_ATTRIBUTES = &H2
Public Const REG_NOTIFY_CHANGE_LAST_SET = &H4
Public Const REG_NOTIFY_CHANGE_NAME = &H1
Public Const REG_NOTIFY_CHANGE_SECURITY = &H8
Public Const REG_OPENED_EXISTING_KEY = &H2
Public Const REG_OPTION_BACKUP_RESTORE = 4
Public Const REG_OPTION_CREATE_LINK = 2
Public Const REG_OPTION_NON_VOLATILE = 0
Public Const REG_OPTION_RESERVED = 0
Public Const REG_OPTION_VOLATILE = 1
Public Const REG_REFRESH_HIVE = &H2
Public Const REG_RESOURCE_LIST = 8
Public Const REG_RESOURCE_REQUIREMENTS_LIST = 10
Public Const REG_SZ = 1
Public Const REG_WHOLE_HIVE_VOLATILE = &H1


Public Const REG_LEGAL_CHANGE_FILTER = (REG_NOTIFY_CHANGE_NAME Or _
REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or _
REG_NOTIFY_CHANGE_SECURITY)


Public Const REG_LEGAL_OPTION = (REG_OPTION_RESERVED Or REG_OPTION_NON_VOLATILE _
Or REG_OPTION_VOLATILE Or REG_OPTION_CREATE_LINK Or REG_OPTION_BACKUP_RESTORE)


Public Const synchronize = &H100000
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)


Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or _
KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not synchronize))


Public Const KEY_EXECUTE = (KEY_READ)


Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or _
KEY_CREATE_SUB_KEY) And (Not synchronize))


Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or _
KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or _
KEY_CREATE_LINK) And (Not synchronize))


Public Function getAddinValue()
Dim lngResult As Long

Dim hKey As Long
Dim value As Long
Dim length As Long
Dim res As Long
Dim value_type As Long
    
    ' Open the key.
    res = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Office\Outlook\Addins\OutlookAddin.Addin", _
        0&, KEY_QUERY_VALUE, hKey)
    If res <> ERROR_SUCCESS Then
        getAddinValue = 0
        Exit Function
    End If

    ' Get the subkey's size.
    res = RegQueryValueEx(hKey, "LoadBehavior", _
        0&, value_type, ByVal 0&, length)
    If res <> ERROR_SUCCESS Then
        getAddinValue = 0
        printLog "Error getting subkey length.", INFO_LEVEL
        Exit Function
       
    End If

    ' Get the subkey's value.
    If RegQueryValueEx(hKey, "LoadBehavior", _
        0&, value_type, value, length) _
            <> ERROR_SUCCESS _
    Then
        printLog "Error getting subkey value.", INFO_LEVEL
    End If
    
    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        printLog "Error closing key.", INFO_LEVEL
    End If
    
    getAddinValue = value
  
End Function

Public Sub setAddinValue(ByVal value As Long)
Dim lngResult As Long

Dim hKey As Long
Dim length As Long
    
    ' Open the key.
    If RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Office\Outlook\Addins\OutlookAddin.Addin", _
        0&, KEY_SET_VALUE, hKey) <> ERROR_SUCCESS _
    Then
        Exit Sub
    End If

    If RegSetValueEx(hKey, "LoadBehavior", _
        0&, REG_DWORD, value, 4&) _
            <> ERROR_SUCCESS _
    Then
        MsgBox "Error getting subkey length."
    End If
   
    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        MsgBox "Error closing key."
    End If
    
  
End Sub


