/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

////////////////////////////////////////////////////
// Use the Outlook Object Model 97 version or later
// Define this according to the Outlook Object
// Model version you are compiling under
////////////////////////////////////////////////////

//#define OUTL8			// Outlook 97
//#define OUTL85		// Outlook 98
//#define OUTL9			// Outlook 2000
#define OUTL11			// Outlook 2003

#pragma warning(disable:4146)
#define IMPPROPS no_namespace
//#define IMPPROPS rename_namespace("OL")

#if defined(OUTL9) // Outlook 2000
    #import "C:/Programmi/Microsoft Office/Office/mso9.dll" IMPPROPS rename("DocumentProperties", "DocProps")
    #import "C:/Programmi/Microsoft Office/Office/msoutl9.olb" IMPPROPS

#elif defined(OUTL11) // Outlook 2003
    #import "C:/Programmi/File Comuni/Microsoft Shared/OFFICE11/mso.dll" IMPPROPS \
		rename("DocumentProperties", "DocProps") \
		rename("RGB","RBGXL")
    #import "C:/Programmi/Microsoft Office/OFFICE11/msoutl.olb" IMPPROPS \
		rename("CopyFile","OLCopyFile")

#elif defined(OUTL85) // Outlook 98
    #import "C:/Programmi/Microsoft Office/Office/mso97.dll" \
        IMPPROPS rename("Font", "IFont") \
        rename("DocumentProperties", "DocProps") \
		rename("RGB","RBGXL")
    #import "C:/Programmi/Microsoft Office/Office/msoutl85.olb" \
        IMPPROPS rename("Font", "IFont") \
        rename ("DocumentProperties", "DocProps") \
		rename("RGB","RBGXL")

#elif defined(OUTL8) // Outlook 97
    #undef IMPPROPS
    #define IMPPROPS rename_namespace("OL")
    #import "stdole2.tlb" IMPPROPS exclude \
        ("Font", "IUnknown", "IDispatch", "IEnumVARIANT", "IFont") \
        include("IPicture")
    #import "fm20.dll" IMPPROPS exclude \
        ("OLE_COLOR", "OLE_HANDLE") rename("Pages", "FMPages") \
        include("IFont")
    #import "C:/Programmi/Microsoft Office/Office/mso97.dll" \
        IMPPROPS rename("DocumentProperties", "DocProps")
    #import "C:/Programmi/Microsoft Office/Office/msoutl8.olb" \
        IMPPROPS rename("_IMailItem", "_MailItem")
#endif // OUTL9

// Alternatively, you can rename the interfaces so that
// you can build any version without changing your code:
#if defined(OUTL85) // Outlook 98
    // These are defined differently in Outlook 2000
    // and in Outlook 98, so make them look the same.
    #define _NameSpacePtr    NameSpacePtr
    #define _FoldersPtr      FoldersPtr
    #define _ItemsPtr        ItemsPtr
    #define _ExplorerPtr     ExplorerPtr
    #define _InspectorPtr    InspectorPtr
    #define _CommandBarsPtr  CommandBarsPtr

#elif defined(OUTL8) // Outlook 97
    // These are defined differently in Outlook 2000
    // and Outlook 97, so make them look the same.
    #define _NameSpacePtr    _INameSpacePtr
    #define _FoldersPtr      FoldersPtr
    #define _ItemsPtr        ItemsPtr
    #define _ExplorerPtr     ExplorerPtr
    #define _InspectorPtr    InspectorPtr
    #define _CommandBarsPtr  CommandBarsPtr
    #define _ApplicationPtr  _DApplicationPtr
    #define _Application     _DApplication
    #define _AppointmentItem _DAppointmentItem
    #define _ContactItem     _DContactItem
    #define _NoteItem        _DNoteItem
    #define _TaskItem        _DTaskItem
#endif // Rename
#pragma warning(default:4146)

// Add to the .cpp files that use Outlook 97's Object model.
#ifdef OUTL8
using namespace OL;
#endif




#define MSG_ERR_AUTH_REQUIRED  TEXT("Not authorized.")
#define MSG_ERR_AUTH_EXPIRED   TEXT("Account expired.")
#define MSG_ERR_SRV_FAULT      TEXT("Server error.")
#define MSG_ERR_NOT_FOUND      TEXT("Server returned NOT FOUND for %s.")
#define MSG_ERR_PROTOCOL_ERROR TEXT("Protocol error.")
#define MSG_ERR_RESP_URI_DIFFERS_FROM_URL TEXT("SyncURI differs from URL.")

#define PREPARING_CONTACTS_SYNC    TEXT("Preparing CONTACTS sync...")
#define PREPARING_APPOINTMENT_SYNC TEXT("Preparing APPOINTMENTS sync...")

#define CONTACTS     TEXT("contact" )
#define APPOINTMENTS TEXT("calendar")
#define TASKS        TEXT("task"    )
#define NOTES        TEXT("note"    )

#define OL_FOLDER_CONTACTS      TEXT("10")  // olFolderContacts
#define OL_FOLDER_APPOINTMENTS  TEXT("9" )  // olFolderCalendar
#define OL_FOLDER_TASKS         TEXT("13")  // olFolderTasks
#define OL_FOLDER_NOTES         TEXT("12")  // olFolderNotes


#define IS_SLOW		TEXT("True")
#define IS_NOT_SLOW TEXT("False")

#define STARTING_STD_SYNC   TEXT("Starting standard sync")

#define STARTING_SLOW_SYNC  TEXT("Starting slow sync")

#define DIM_LOCAL_TEMP  256
#define DIM_LINE        2048
#define DIM_FILENAME    1024
#define DIM_ID          512
#define DIM_ITEM        4096
#define DIM_RETURN_ITEM 4096


#define DIM_RET_ERROR_MESSAGE 1024

#define ALL TEXT("ALL")
#define DEL TEXT("DEL")
#define MOD TEXT("MOD")
#define NEW TEXT("NEW")

#define CDATA_START     TEXT("<![CDATA[")
#define CDATA_END       TEXT("]]>")

#define SET_ALL_ITEMS       TEXT("Current items number is %i"  )
#define NO_SYNC             TEXT("No sync for this source."     )
#define MESSAGE_FROM_SERVER TEXT("Response from server:"        )
#define SERVER_NEW_ITEMS    TEXT("   New items are:\t\t%i"      )
#define SERVER_UPDATE_ITEMS TEXT("   Updated items are:\t\t%i"   )
#define SERVER_DELETE_ITEMS TEXT("   Deleted items are:\t\t%i"   )

#define MESSAGE_TO_SERVER   TEXT("Send sync info to the server:")
#define CLIENT_NEW_ITEMS    TEXT("   New items are:\t\t%i"      )
#define CLIENT_UPDATE_ITEMS TEXT("   Updated items are:\t\t%i"   )
#define CLIENT_DELETE_ITEMS TEXT("   Deleted items are:\t\t%i"   )

#define ENDING_SYNC         TEXT("Ending sync...")
#define SYNC_ENDED          TEXT("Sync ended"    )
#define SEPARATOR			TEXT("==========="   )
#define SEPARATOR_BLANK     TEXT("   "           )

#define DEBUG_LEVEL            T("DEBUG"         )
#define INFO_LEVEL             T("INFO"          )
#define ERROR_LEVEL            T("ERROR"         )

#define DIR_ALL_ITEM_CONTACTS TEXT("AllItemContacts")
#define DIR_NEW_ITEM_CONTACTS TEXT("NewItemContacts")
#define DIR_MOD_ITEM_CONTACTS TEXT("ModItemContacts")

#define DIR_ALL_ITEM_CALENDARS TEXT("AllItemCalendars")
#define DIR_NEW_ITEM_CALENDARS TEXT("NewItemCalendars")
#define DIR_MOD_ITEM_CALENDARS TEXT("ModItemCalendars")

#define DIR_ALL_ITEM_TASKS TEXT("AllItemTasks")
#define DIR_NEW_ITEM_TASKS TEXT("NewItemTasks")
#define DIR_MOD_ITEM_TASKS TEXT("ModItemTasks")

#define DIR_ALL_ITEM_NOTES TEXT("AllItemNotes")
#define DIR_NEW_ITEM_NOTES TEXT("NewItemNotes")
#define DIR_MOD_ITEM_NOTES TEXT("ModItemNotes")


// -------------------------------- Includes -------------------------------
#include <windows.h>
#include <stdio.h>
#include <direct.h>
#include <io.h>
#include <fcntl.h>

#include "outlook/OutlookConfig.h"
#include "outlook/Container.h"
#include "outlook/WindowsSyncSource.h"

#include "base/Log.h"
#include "base/util/utils.h"
#include "http/Win32TransportAgent.h"
#include "spdm/spdmutils.h"
#include "spdm/DMTree.h"
#include "spdm/DMTreeFactory.h"
#include "spds/spdsutils.h"
#include "spds/constants.h"
#include "client/Sync4jClient.h"

#include "ptypes/ptypes.h"

#include "outlook/utils.h"
#include "base/memTracker.h"


//--------------------------- Public Functions ----------------------------
void getItemsFromFileSystem      (Container* c, wchar_t* path, const wchar_t* sourceName, wchar_t* typeOfArray);
void fillItemsArrayFromFileSystem(Container* c, wchar_t* path, wchar_t* dirName,
								  wchar_t** ptrArray, int itemNumber, wchar_t* typeOfArray, const wchar_t* sourceName);
int getDelItemsFromString    (Container* c, wchar_t* xml);
int getAllItemsKeyFromString (Container* c, wchar_t* xml);
wchar_t* manageNewItem(SyncItem* item, const wchar_t* sourceName);
wchar_t* manageUpdatedItem(SyncItem* item, const wchar_t* sourceName);
wchar_t* manageDeletedItem(SyncItem* item);

